
#include "ASM.h"

///////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////
double DC(IplImage* limg, IplImage* rimg, int x, int y,int width,int height,int f)
{
    if (x < (f+WINDOW/2)||(x+WINDOW/2)>width) return 10000;
    if (y < (WINDOW/2)||(y+WINDOW/2)>height) return 10000;
  int i,j;
  double cost=0;
  for(i=-WINDOW/2;i<=WINDOW/2;i++)
    {
      for(j=-WINDOW/2;j<=WINDOW/2;j++)
	{
	  cost+=abs((double)limg->imageData[(y+j)*width+x+i]-(double)rimg->imageData[(y+j)*width+x+i-f]);
	}
    }
  return cost;//(WINDOW*WINDOW);//abs(limg.imageData[y+x]-rimg.imageData[y+x-f]);
}
////////////////////////////////////////////////////////////////////////////////////////
int SC(int fp,int fq)
{
  return C*abs(fp-fq);
}

/////////////////////////////////////////////////////////////////////////////////////////
int main(){
   typedef Graph<int, int, int> GraphType;
	srand((unsigned)time(NULL));

   int i,j;
   int x,y;
   int A[N];
   int labelnum;
   int E=1000000000;
   int newE;
   int success;
   int AP,AQ;
   int BP,BQ;
   int VA,VB;
   int APOS;
   GraphType* graph=NULL;
   clock_t t1, t2;
   t1 = clock();



    IplImage* rightimg = cvLoadImage("rightb.bmp",CV_LOAD_IMAGE_GRAYSCALE);
    IplImage* leftimg= cvLoadImage("leftb.bmp",CV_LOAD_IMAGE_GRAYSCALE);

    if(leftimg==NULL || rightimg==NULL ){
        fprintf(stderr,"読み込み失敗\n");
        return 1;
    }
    const int width=leftimg->width;
    const int height=leftimg->height;
    const int nodenum=width*height;
    ///////////////

      IplImage* resimg = cvCreateImage(cvSize(width, height), IPL_DEPTH_8U, 1);    
      unsigned int B[width][height];
      printf("%d %d\n",resimg->width,width);
      printf("%d %d\n",resimg->height,height);
      for (y=0; y<height; y++) {
	    for (x=0; x<width; x++) {
  	      B[x][y] =0;//rightimg->imageData[y*width+x];
	      cvSet2D(resimg,(y*width+x)/width,(y*width+x)%width,cvScalar(255*B[x][y]/N));
	      //resimg->imageData[y*width+x]=leftimg->imageData[y*width+x];
	    }
	  }
	  i=0;
	  while(i<ROOP)
	    {
	      success=0;
	      for(j=0;j<(N+1);j++)
		{
		  graph = new GraphType(3*nodenum, 6*nodenum);
		  // newE=0;
		  APOS=nodenum;
		  for (y=0; y<height; y++) {
		    for (x=0; x<width; x++) {
		      graph -> add_node();
		      graph -> add_tweights(y*width+x, DC(leftimg, rightimg, x, y,width,height,B[x][y]), DC(leftimg, rightimg, x, y,width,height, j));	
		    }
		  }
		  for (y=0; y<height; y++) {
		    for (x=0; x<width; x++) {
		      if((x+1)<width)
			{
			  graph -> add_node();
			  graph -> add_tweights(APOS, SC(B[x][y],B[x][y+1]),SC(j,j));	 
			  graph -> add_edge(APOS, y*width+x, SC(B[x][y],j), SC(B[x][y],j));
			  graph -> add_edge(APOS, y*width+x+1, SC(j,B[x+1][y]),SC(j,B[x+1][y]));
			  APOS++;
			}
		      if((y+1)<height)
			{
			  graph -> add_node();
			  graph -> add_tweights(APOS, SC(B[x][y],B[x][y+1]),SC(j,j));	 
			  graph -> add_edge(APOS, y*width+x, SC(B[x][y],j), SC(B[x][y],j));
			  graph -> add_edge(APOS, (y+1)*width+x, SC(j,B[x][y+1]),SC(j,B[x][y+1]));
			  APOS++;
			}
		    }
		  }
		  
		  int flow=graph->maxflow();

		  newE= flow;

		  if(newE<E){
		    E=newE;
		    success=1;
		    for (int y=0; y<height; y++) {
		      for (int x=0; x<width; x++) {
			if (graph -> what_segment(y*width+x) == GraphType::SOURCE) {
			  B[x][y]=j;
			}
		      }
		    }
		  }
		  delete graph;
		  printf("E=%d\n",E);
		}
	      printf("\n");
	      if(success==0)break;
	    }

	  for (int y=0; y<height; y++) {
	    for (int x=0; x<width; x++) {
	      cvSet2D(resimg,(y*width+x)/width,(y*width+x)%width,cvScalar(255*B[x][y]/N));
	    }
	  }
	  cvNamedWindow("result",CV_WINDOW_AUTOSIZE);
	  cvShowImage("result",resimg);
	  cvSaveImage("result.bmp",resimg);
	  t2 = clock();
	  printf("%f\n", (double)(t2 - t1) / CLOCKS_PER_SEC);
	       cvWaitKey();
         cvDestroyAllWindows();

      return 0;
}
